program bin2hex;
(* Font file to Hex file for mprom firmware   by MoroboshiLUM *)

uses
  sysutils;
  
 type
   a = array [0..$3FFFF] of BYTE;
   ap = ^a;
   
 var
  p : ap;
  f,h : file;
  g : textfile;
  i,j,n : integer;
  sum : byte;
begin
  GetMem(p,$40000);
  FillChar(p^[0],$40000,$FF);
  assignFile(F,'kfont.fnt');
  assignFile(h,'afont.fnt');
  assignFile(g,'font.hex');
  reset(f,1); reset(h,1);
  rewrite(g);
  BlockRead(f,p^[0],$3F000,i);
  n:=filesize(h)-4096;
  seek(h,n);
  BlockRead(h,p^[$3f000],$1000,i);
  writeln(g,':02000002A0005C');
  for i:=0 to $0fff do begin
    sum:=$10+((i and $FF0) SHR 4)+((i and $F) SHL 4);
    write(g,Format(':10%.04X00',[(i and $fff)*$10]));
    for j:=0 to $f do begin
      sum:=sum+p^[i*$10+j];
      write(g,Format('%.02X',[p^[i*$10+j]]));
    end;
    sum:=0-sum;
    writeln(g,Format('%.02X',[sum]));
  end;
  writeln(g,':02000002B0004C');
  for i:=$1000 to $1fff do begin
    sum:=$10+((i and $FF0) SHR 4)+((i and $F) SHL 4);
    write(g,Format(':10%.04X00',[(i and $fff)*$10]));
    for j:=0 to $f do begin
      sum:=sum+p^[i*$10+j];
      write(g,Format('%.02X',[p^[i*$10+j]]));
    end;
    sum:=0-sum;
    writeln(g,Format('%.02X',[sum]));
  end;
  writeln(g,':02000002C0003C');
  for i:=$2000 to $2fff do begin
    sum:=$10+((i and $FF0) SHR 4)+((i and $F) SHL 4);
    write(g,Format(':10%.04X00',[(i and $fff)*$10]));
    for j:=0 to $f do begin
      sum:=sum+p^[i*$10+j];
      write(g,Format('%.02X',[p^[i*$10+j]]));
    end;
    sum:=0-sum;
    writeln(g,Format('%.02X',[sum]));
  end;
  writeln(g,':02000002D0002C');
  for i:=$3000 to $3fff do begin
    sum:=$10+((i and $FF0) SHR 4)+((i and $F) SHL 4);
    write(g,Format(':10%.04X00',[(i and $fff)*$10]));
    for j:=0 to $f do begin
      sum:=sum+p^[i*$10+j];
      write(g,Format('%.02X',[p^[i*$10+j]]));
    end;
    sum:=0-sum;
    writeln(g,Format('%.02X',[sum]));
  end;
  closefile(g);
  closefile(h);
  closefile(f);
end.
