/* RS-232C BIOS & Debug input/output routines definations */
/* programmed by M.yanagisawa.(MoroboshiLUM)              */

/* BIOS */
#define COMMBIOS 0x30

#define COM_OPEN	0
#define COM_CLOSE	1
#define COM_SEND	2
#define COM_RECV	3
#define COM_CLRBUF	4
#define COM_GETCHAR	5
#define COM_GETSTAT	6

#define _CR 0x0d
#define _LF 0x0a
#define _TAB 0x09
#define _BS 0x08
#define _ESC 0x1b

#define MAX_INPUT_LEN 128

void initcomm(void);
void PUTCHAR(char c);
char GETCHAR(int isecho);
void PUTMSG(char *s);
void putmsg(char *s);
void getmsg(int isecho,char *s);
